;*************************** main function *************************************
	
MAIN:          
	MOVLW	0x3		; OSCFRQ = 0x03; set internal oscillator to 8MHz
	MOVLB	0x11
	MOVWF	OSCFRQ
	MOVLB	0x3E		; ANSELB = 0; configure all PORTB pins as digital
	CLRF	ANSELB
	MOVLB	0x0		; PORTB  = 0; PORTB initial state
	CLRF	PORTB
	MOVLW	0xF		; configure RB0 ~ 3 as input pins
	MOVWF	TRISB
	MOVLW	0xF		; enable RB0, RB1, RB2 and RB3 internal pull ups
	MOVLB	0x3E
	MOVWF	WPUB
	MOVLB	0xE		; INTE   = 0; clear external interrupt flag bit
	BCF	PIE0, 0x0
	BSF	INTCON, 0x7	; GIE    = 1; enable global interrupts
	BCF	INTCON, 0x0	; INTEDG = 0; set external Interrupt on falling edge
	BSF	PIE0, 0x0	; INTE   = 1; enable external interrupt     
	CALL	Wait		;__delay_ms(1000);  // wait 1 second  
	CALL	I2C_Init	; I2C_Init(100000); initialize I2C bus with clock frequency of 100kHz
	CALL	LCD_Begin	; initialize LCD module
	
;Mainloop	
	
A062:	
	MOVLB	0x0
	BTFSC	PORTB, 0x1	; if(!button1); if button B1 is pressed
	GOTO	A16A 
	MOVLW	0x1		; if(debounce(1)) call debounce function (make sure if B1 is pressed)
	CALL	debounce
	BTFSS	STATUS, 0x0
	GOTO	A16A 
	MOVLB	0x0
	CLRF	i		; i = 0;
	CLRF	__pcstackBANK0	; hour = edit(1, 1, hour)= edit (x,y,parameter)
	INCF	__pcstackBANK0, F;y = 1
	MOVF	hour, W
	MOVWF	0x63		; =hour
	MOVF	0x63, W
	MOVWF	al		; =hour
	MOVLW	0x1
	CALL	edit
	MOVLB	0x0
	MOVWF	0x64	
	MOVF	0x64, W
	MOVWF	hour
	CLRF	__pcstackBANK0	; minute = edit(4, 1, minute);
	INCF	__pcstackBANK0, F
	MOVF	minute, W
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	al
	MOVLW	0x4
	CALL	edit
	MOVLB	0x0
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	minute       

A089:	; while(debounce(1)); call debounce function (wait for button B1 to be released)
	MOVLW	0x1
	CALL	debounce
	BTFSS	STATUS, 0x0
	GOTO	A0AA
	GOTO	A089        

A0AA:	; while(!button2) if button RB2 button is pressed
	MOVLB	0x0
	BTFSS	PORTB, 0x2
	GOTO	A090

A090:	; w_day++; increment day
	MOVLW	0x1
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	ADDWF	w_day, F
	MOVLW	0x8	; if(w_day > 7) w_day = 1;
	SUBWF	w_day, W
	BTFSS	STATUS, 0x0
	GOTO	A09B
	CLRF	w_day
	INCF	w_day, F
;
A09B:	; w_day_display()
	CALL	w_day_display
	CALL	WAIT	;__delay_ms(200);

	MOVLW	0x2	; LCD_Goto(1, 2);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	row
	MOVLW	0x1
	CALL	LCD_Goto
	MOVLW	0x0	; LCD_Print("   "); print 3 spaces
	MOVWF	count
	MOVLW	0x90
	MOVWF	i
	CALL	LCD_Print
	CALL	blink		; blink(); call blink function
	CALL	w_day_display	; w_day_display();
	CALL	blink		; blink(); call blink function
	MOVLB	0x0		; if(!button1) if button B1 is pressed
	BTFSC	PORTB, 0x1
	GOTO	A0AA
	MOVLW	0x1		
	CALL	debounce	; if(debounce(1)) debounce function (make sure if B1 is pressed)
	BTFSS	STATUS, 0x0
	GOTO	A0AA
	MOVLW	0x2	; m_day  = edit(5,  2, m_day);
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	m_day, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x5
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	m_day
	MOVLW	0x2	; month  = edit(8,  2, month);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	month, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x8
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	month
	MOVLW	0x2	; year   = edit(13, 2, year);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	year, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0xD
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	year

A0FF:	; while(debounce(1)); call debounce function (wait for button B1 to be released)
	MOVLW	0x1
	CALL	debounce
	BTFSC	STATUS, 0x0
	GOTO	A0FF
	MOVLB	0x0	 ; minute = decimal_to_bcd(minute);
	MOVF	minute, W
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVW	0x63
	MOVF	0x63, W
	MOVWF	minute
	MOVF	hour, W	; hour   = decimal_to_bcd(hour);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	hour
	MOVF	m_day, W	; m_day  = decimal_to_bcd(m_day);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	m_day
	MOVF	month, W	; month  = decimal_to_bcd(month);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	month

	MOVF	year, W		; year   = decimal_to_bcd(year);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	year        

	; write data to DS3231 RTC

	CALL	I2C_Start
	MOVLW	0xD0
	CALL	I2C_Write	; RTC chip address       
	MOVLW	x0
	CALL	I2C_Write	; send register address       
	MOVLW	0x0
	CALL	I2C_Write	; reset seconds and start oscillator  
	MOVLB	0x0
	MOVF	minute, W
	CALL	I2C_Write	; write minute value to RTC chip     
	MOVLB	0x0
	MOVF	hour, W
	CALL	I2C_Write	; write hour value to RTC chip
	MOVLB	0x0
	MOVF	w_day, W	
	CALL	I2C_Write	; write day of the week value to RTC chip   
	MOVLB	0x0
	MOVF	m_day, W
	CALL	I2C_Write	; write date (day of the month) value to RTC chip   
	MOVLB	0x0
	MOVF	month, W
	CALL	I2C_Write	; write month value to RTC chip    
	MOVLB	0x0
	MOVF	year, W
	CALL	I2C_Write	; write year value to RTC chip
	CALL	I2C_Stop         ; stop I2C
	CALL	WAIT	   ;__delay_ms(200);

A16A:	; if(!button3) if RB3 button is pressed
	MOVLB	0x0
	BTFSC	PORTB, 0x3
	GOTO	A248
	MOVLW	0x3; if(debounce(3)) call debounce function (make sure if B3 is pressed)
	CALL	debounce
	BTFSS	STATUS, 0x0
	GOTO	A248
	MOVLW	0x5	; i = 5;
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	i
	MOVLW	0x3	; alarm1_hour   = edit(5, 3, alarm1_hour);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	alarm1_hour, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x5
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	alarm1_hour
	MOVLW	0x3	; alarm1_minute = edit(8, 3, alarm1_minute);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	alarm1_minute, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x8
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	alarm1_minute
	MOVLW	0x3	; alarm1_status = on_off(18, 3, alarm1_status);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	alarm1_status, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x12
	CALL	A6D2
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	alarm1_status
	MOVLW	0x5	; i = 5;
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	i
	MOVLW	0x4	; alarm2_hour   = edit(5, 4, alarm2_hour);
	MOVWF	0x63	
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	alarm2_hour, W
	MOVWF	0x64	
	MOVF	0x64, W
	MOVWF	al	
	MOVLW	0x5
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	alarm2_hour
	MOVLW	0x4	; alarm2_minute = edit(8, 4, alarm2_minute);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	alarm2_minute, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x8
	CALL	edit
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	alarm2_minute
	MOVLW	0x4	; alarm2_status = on_off(18, 4, alarm2_status);
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	__pcstackBANK0
	MOVF	alarm2_status, W
	MOVWF	0x64
	MOVF	0x64, W
	MOVWF	al
	MOVLW	0x12
	CALL	A6D2
	MOVLB	0x0
	MOVWF	0x65
	MOVF	0x65, W
	MOVWF	alarm2_status

A1DC:	; while(debounce(3)); call debounce function (wait for button B3 to be released)
	MOVLW	0x3
	CALL	debounce
	BTFSC	STATUS, 0x0
	GOTO	A1DC
	
; convert decimal to BCD

	MOVLB	0x0	; alarm1_minute = decimal_to_bcd(alarm1_minute);
	MOVF	alarm1_minute, W
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	alarm1_minute
	MOVF	alarm1_hour, W	; alarm1_hour   = decimal_to_bcd(alarm1_hour);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	alarm1_hour
	MOVF	alarm2_minute, W; alarm2_minute = decimal_to_bcd(alarm2_minute);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	alarm2_minute
	MOVF	alarm2_hour, W	; alarm2_hour   = decimal_to_bcd(alarm2_hour);
	CALL	decimal_to_bcd
	MOVLB	0x0
	MOVWF	0x63
	MOVF	0x63, W
	MOVWF	alarm2_hour
; end conversion
; write alarms data to DS3231
	CALL	I2C_Start
	MOVLW	0xD0
	CALL	I2C_Write	; RTC chip address  
	MOVLW	0x7
	CALL	I2C_Write	; send register address (alarm1 seconds)
	MOVLW	0x0
	CALL	I2C_Write	 ; write 0 to alarm1 seconds
	MOVLB	0x0
	MOVF	alarm1_minute, W
	CALL	I2C_Write	; write alarm1 minutes
	MOVLB	0x0
	MOVF	alarm1_hour, W
	CALL	I2C_Write	; write alarm1 hours
	MOVLW	0x80
	CALL	I2C_Write	; alarm1 when hours, minutes, and seconds match
	MOVLB	0x0
	MOVF	alarm2_minute, W
	CALL	I2C_Write	; write alarm2 minutes
	MOVLB	0x0
	MOVF	alarm2_hour, W
	CALL	I2C_Write	; write alarm2 hours
	MOVLW	0x80
	CALL	I2C_Write	; alarm2 when hours and minutes match
; I2C_Write(4 | alarm1_status | (alarm2_status << 1)); write data to control register (enable interrupt when alarm)
	MOVLB	0x0
	LSLF	alarm2_status, W
	IORWF	alarm1_status, W
	IORLW	0x4
	CALL	I2C_Write    
	MOVLW	0x0
	CALL	I2C_Write	; clear alarm flag bits
	CALL	I2C_Stop
	CALL	Wait		; __delay_ms(200);  // wait 200ms

A248:	; if(!button2 && LED_PIN){ when button B2 pressed with alarm (Reset and turn OFF the alarm)
	MOVLB	0x0
	BTFSS	PORTB, 0x2
	BTFSS	PORTB, 0x4
	GOTO	A27C
	BCF	PORTB, 0x4	; LED_PIN = 0; turn OFF alarm indicator
	CALL	I2C_Start         
	MOVLW	0xD0
	CALL	I2C_Write	; RTC chip address       
	MOVLW	0xE
	CALL	I2C_Write	; send register address (control register)
; write data to control register (Turn OFF the occurred alarm and keep the other as it is)
; I2C_Write(4 | ((!(status_reg & 1)) & alarm1_status) | (((!((status_reg >> 1) & 1)) & alarm2_status) << 1));
	MOVLB	0x0
	MOVF	status_reg, W
	MOVWF	0x63
	MOVLW	0x1
A25C:	
	LSRF	0x63, F
	DECFSZ	WREG, F
	GOTO	A25C
	BTFSC	0x63, 0x0
	GOTO	A263
	MOVLW	0x1
	GOTO	A264
A263:	
	MOVLW	0x0
A264:	
	ANDWF	alarm2_status, W
	MOVWF	0x64
	MOVLW	0x1
A267:	
	LSLF	0x64, F
	DECFSZ	WREG, F
	GOTO	A267
	BTFSC	status_reg, 0x0
	GOTO	A26E
	MOVLW	0x1
	GOTO	A26F
A26E:	
	MOVLW	0x0
A26F:	
	ANDWF	alarm1_status, W
	IORWF	0x64, W
	IORLW	0x4
	CALL	I2C_Write    
	MOVLW	0x0
	CALL	I2C_Write	; clear alarm flag bits
	CALL	I2C_Stop
A27C:	
	CALL	RTC_read	; read time and date from RTC chip
	CALL	alarms_read_display	; read and display alarms
	CALL	RTC_display	; print time & date
	CALL	Wait	;__delay_ms(50);   // wait 50 ms
	GOTO	A062
